
from catalog import ImageCatalog, Sequence
# from imageengine import Toto
from imageengine import IImageEngine
from imageengine import PixelType
from preprocessing import WhiteEstimator

def remove_traps(sequence, channel_id, trap_aabb):
    """Remove the traps in the input sequence

    :param Sequence sequence:
    :param str channel_id:
    :param Aabb trap_aabb:
    """
    white_estimator = WhiteEstimator(open_size=75, close_size=75, average_size=75)
    white_estimate = white_estimator.estimate_white([sequence], [channel_id])
    print(white_estimate)

    uniform_stack = IImageEngine.get_instance().create_hyperstack(width=white_estimate.width(), height=white_estimate.height(), num_slices=1, num_frames=sequence.num_frames, num_channels=1, pixel_type=PixelType.F32)

    for frame_index in range(sequence.num_frames):
        non_uniform_frame = IImageEngine.get_instance().load_image(sequence.get_image_file_path(channel_index=0, frame_index=frame_index, slice_index=0))
        uniform_frame = IImageEngine.get_instance().divide(non_uniform_frame, white_estimate)
        uniform_stack.set_image(frame_index=frame_index, image=uniform_frame)

    #num_expected_traps = 13  # 13 traps are completely visible in the 
    #assert num_traps = num_expected_traps
    
    #non_uniform_stack = sequence.as_stack()
    #uniform_stack = IImageEngine.get_instance().divide(non_uniform_stack, white_estimate)
    # IImageEngine.get_instance().save_as_tiff(white_estimate, './white_estimate.tiff')
    